<template>
    <div>
      <h1>Vehicles List</h1>
      <ul>
  <li v-for="vehicle in vehicles" :key="vehicle.id">
        
    <div>
      <h3>{{ vehicle.vehicleMark }} - {{ vehicle.vehicleType }}</h3>
      <p>Price: {{ vehicle.vehiclePrice }}</p>
      <p>Type: {{ vehicle.vehicleType }}</p>
      <p>Transmission: {{ vehicle.vehicleTransmissions }}</p>
      <p>Fuel Type: {{ vehicle.fuelType }}</p>
      <p>Doors: {{ vehicle.doorNumber }}</p>
      <img :src="vehicle.decodedImage || ''" alt="Vehicle Image" width="300" height="300">
      <p>People in Car: {{ vehicle.peopleInCarNumber }}</p>
      <p>Consumption: {{ vehicle.consumption }}</p>
      <p>Status: {{ vehicle.status }}</p>
      <p>Description: {{ vehicle.description }}</p>
    </div>
  </li>
</ul>
    </div>
  </template>
  
  <script>
  import axios from 'axios';
  
  export default {
    data() {
      return {
        vehicles: [],
      };
    },
    mounted() {
      
      this.fetchVehicles();
    },
    methods: {
  fetchVehicles() {
    axios.get('/api/vehicles')
      .then((response) => {
        this.vehicles = response.data;
        this.decodeImages();
      })
      .catch((error) => {
        console.error('Error fetching vehicles:', error);
      });
  },
  async decodeImages() {
    for (const vehicle of this.vehicles) {
      try {
        vehicle.decodedImage = await this.getDecodeImage(vehicle.image);
      } catch (error) {
        console.error('Error decoding image:', error);
      }
    }
  },
  async getDecodeImage(encodedImage) {
    return new Promise((resolve, reject) => {
      if (encodedImage) {
        const img = new Image();
        img.src = `data:image/png;base64,${encodedImage}`;

        img.onload = () => resolve(img.src);
        img.onerror = (error) => reject(error);
      } else {
        reject(new Error('Encoded image is empty.'));
      }
    });
  },
},

  
};
</script>
  